Advertisement
Guest User

Untitled

a guest
Feb 23rd, 2019
75
0
Never
Not a member of Pastebin yet? Sign Up, it unlocks many cool features!
text 22.77 KB | None | 0 0
  1. ====== The classic test command ======
  2.  
  3. ''test <EXPRESSION>''
  4.  
  5. ''[ <EXPRESSION> ]''
  6.  
  7. ===== General syntax =====
  8.  
  9. This command allows you to do various tests and sets its exit code to 0 (//TRUE//) or 1 (//FALSE//) whenever such a test succeeds or not. Using this exit code, it's possible to let Bash react on the result of such a test, here by using the command in an if-statement:
  10. <code>
  11. #!/bin/bash
  12. # test if /etc/passwd exists
  13.  
  14. if test -e /etc/passwd; then
  15. echo "Alright man..." >&2
  16. else
  17. echo "Yuck! Where is it??" >&2
  18. exit 1
  19. fi
  20. </code>
  21.  
  22.  
  23. The syntax of the test command is relatively easy. Usually it's the command name "''test''" followed by a test type (here "''-e''" for "file exists") followed by test-type-specific values (here the filename to check, "''/etc/passwd''").
  24.  
  25. There's a second standardized command that does exactly the same: the command "''[''" - the difference just is that it's called "''[''" and the last argument to the command must be a "'']''": It forms "''**[ <EXPRESSION> ]**''"
  26.  
  27. Let's rewrite the above example to use it:
  28. <code>
  29. #!/bin/bash
  30. # test if /etc/passwd exists
  31.  
  32. if [ -e /etc/passwd ]; then
  33. echo "Alright man..." >&2
  34. else
  35. echo "Yuck! Where is it??" >&2
  36. exit 1
  37. fi
  38. </code>
  39. One might **think** now that these "[" and "]" belong to the syntax of Bash's if-clause: **No they don't! It's a simple, ordinary command, still!**
  40.  
  41. Another thing you have to remember is that if the test command wants one parameter for a test, you have to give it one parameter. Let's check for some of your music files:
  42. <code>
  43. #!/bin/bash
  44.  
  45. mymusic="/data/music/Van Halen/Van Halen - Right Now.mp3"
  46.  
  47. if [ -e "$mymusic" ]; then
  48. echo "Let's rock" >&2
  49. else
  50. echo "No music today, sorry..." >&2
  51. exit 1
  52. fi
  53. </code>
  54. As you definitely noted, the filename contains spaces. Since we call a normal ordinary command ("test" or "[") the shell will word-split the expansion of the variable ''mymusic'': You need to quote it when you don't want the ''test''-command to complain about too many arguments for this test-type! If you didn't understand it, please read the [[syntax:words | article about words...]]
  55.  
  56. Please also note that the file-tests want **one filename** to test. Don't give a glob (filename-wildcards) as it can expand to many filenames => **too many arguments!**
  57.  
  58. __**Another common mistake**__ is to provide too **few** arguments:
  59. <code>
  60. [ "$mystring"!="test" ]
  61. </code>
  62. This provides exactly **one** test-argument to the command. With one parameter, it defaults to the ''-n'' test: It tests if a provided string is empty (''FALSE'') or not (''TRUE'') - due to the lack of **spaces to separate the arguments** the shown command always ends ''TRUE''!
  63.  
  64. Well, I addressed several basic rules, now let's see what the test-command can do for you. The Bash test-types can be split into several sections: **file tests**, **string tests**, **arithmetic tests**, **misc tests**.
  65. Below, the tests marked with :!: are non-standard tests (i.e. not in SUS/POSIX/etc..).
  66.  
  67. ===== File tests =====
  68. This section probably holds the most tests, I'll list them in some logical order. Since Bash 4.1, all tests related to permissions respect ACLs, if the underlying filesystem/OS supports them.
  69.  
  70. ^ Operator syntax ^ Description | |
  71. | **-a** <FILE> | True if <FILE> exists. :!: (not recommended, may collide with ''-a'' for ''AND'', see below) | |
  72. | **-e** <FILE> | True if <FILE> exists. | |
  73. | **-f** <FILE> | True, if <FILE> exists and is a **regular** file. | |
  74. | **-d** <FILE> | True, if <FILE> exists and is a **directory**. ||
  75. | **-c** <FILE> | True, if <FILE> exists and is a **character special** file. | |
  76. | **-b** <FILE> | True, if <FILE> exists and is a **block special** file. | |
  77. | **-p** <FILE> | True, if <FILE> exists and is a **named pipe** (FIFO). | |
  78. | **-S** <FILE> | True, if <FILE> exists and is a **socket** file. | |
  79. | **-L** <FILE> | True, if <FILE> exists and is a **symbolic link**. | |
  80. | **-h** <FILE> | True, if <FILE> exists and is a **symbolic link**. | |
  81. | **-g** <FILE> | True, if <FILE> exists and has **sgid bit** set. | |
  82. | **-u** <FILE> | True, if <FILE> exists and has **suid bit** set. | |
  83. | **-r** <FILE> | True, if <FILE> exists and is **readable**. | |
  84. | **-w** <FILE> | True, if <FILE> exists and is **writable**. | |
  85. | **-x** <FILE> | True, if <FILE> exists and is **executable**. | |
  86. | **-s** <FILE> | True, if <FILE> exists and has size bigger than 0 (**not empty**). | |
  87. | **-t** <fd> | True, if file descriptor <fd> is open and refers to a terminal. | |
  88. | <FILE1> **-nt** <FILE2> | True, if <FILE1> is **newer than** <FILE2> (mtime). :!: | |
  89. | <FILE1> **-ot** <FILE2> | True, if <FILE1> is **older than** <FILE2> (mtime). :!: | |
  90. | <FILE1> **-ef** <FILE2> | True, if <FILE1> and <FILE2> refer to the **same device and inode numbers**. :!: | |
  91.  
  92.  
  93.  
  94. ===== String tests =====
  95. ^Operator syntax^Description^
  96. |**-z** <STRING>|True, if <STRING> is **empty**.|
  97. |**-n** <STRING>|True, if <STRING> is **not empty** (this is the default operation).|
  98. |<STRING1> **=** <STRING2>|True, if the strings are **equal**.|
  99. |<STRING1> **!=** <STRING2>|True, if the strings are **not equal**.|
  100. |<STRING1> **<** <STRING2>|True if <STRING1> sorts **before** <STRING2> lexicographically (pure ASCII, not current locale!). Remember to escape! Use ''\<''|
  101. |<STRING1> **>** <STRING2>|True if <STRING1> sorts **after** <STRING2> lexicographically (pure ASCII, not current locale!). Remember to escape! Use ''\>''|
  102.  
  103. ===== Arithmetic tests =====
  104. ^Operator syntax^Description^
  105. |<INTEGER1> **-eq** <INTEGER2>|True, if the integers are **equal**.|
  106. |<INTEGER1> **-ne** <INTEGER2>|True, if the integers are **NOT equal**.|
  107. |<INTEGER1> **-le** <INTEGER2>|True, if the first integer is **less than or equal** second one.|
  108. |<INTEGER1> **-ge** <INTEGER2>|True, if the first integer is **greater than or equal** second one.|
  109. |<INTEGER1> **-lt** <INTEGER2>|True, if the first integer is **less than** second one.|
  110. |<INTEGER1> **-gt** <INTEGER2>|True, if the first integer is **greater than** second one.|
  111.  
  112. ===== Misc syntax =====
  113. ^ Operator syntax ^ Description ^
  114. | <TEST1> **-a** <TEST2> | True, if <TEST1> **and** <TEST2> are true (AND). Note that ''-a'' also may be used as a file test (see above) |
  115. | <TEST1> **-o** <TEST2> | True, if either <TEST1> **or** <TEST2> is true (OR). |
  116. | **!** <TEST> | True, if <TEST> is **false** (NOT). |
  117. | **(** <TEST> **)** | Group a test (for precedence). **Attention:** In normal shell-usage, the "(" and ")" must be escaped; use "\(" and "\)"! |
  118. | **-o** <OPTION_NAME> | True, if the [[internals:shell_options| shell option]] <OPTION_NAME> is set. |
  119. | **-v** <VARIABLENAME> | True if the variable <VARIABLENAME> has been set. Use ''var[n]'' for array elements. |
  120. | **-R** <VARIABLENAME> | True if the variable <VARIABLENAME> has been set and is a nameref variable (since 4.3-alpha) |
  121.  
  122.  
  123.  
  124. ===== Number of Arguments Rules =====
  125.  
  126. The ''test'' builtin, especially hidden under its ''['' name, may seem simple but is in fact **causing a lot of trouble sometimes**.
  127. One of the difficulty is that the behaviour of ''test'' not only depends on its arguments but also on the **number of its arguments**.
  128.  
  129. Here are the rules taken from the manual (__**Note:**__ This is for the command ''test'', for ''['' the number of arguments is calculated without the final '']'', for example ''[ ]'' follows the "zero arguments" rule):
  130.  
  131. * **0 arguments**
  132. * The expression is false.
  133. * **1 argument**
  134. * The expression is true if, and only if, the argument is not null
  135. * **2 arguments**
  136. * If the first argument is ''!'' (exclamation mark), the expression is true if, and only if, the second argument is null
  137. * If the first argument is one of the unary conditional operators listed above under the syntax rules, the expression is true if the unary test is true
  138. * If the first argument is not a valid unary conditional operator, the expression is false
  139. * **3 arguments**
  140. * If the second argument is one of the binary conditional operators listed above under the syntax rules, the result of the expression is the result of the binary test using the first and third arguments as operands
  141. * If the first argument is ''!'', the value is the negation of the two-argument test using the second and third arguments
  142. * If the first argument is exactly ''('' and the third argument is exactly '')'', the result is the one-argument test of the second argument. Otherwise, the expression is false. The ''-a'' and ''-o'' operators are considered binary operators in this case (**Attention:** This means the operator ''-a'' is not a file operator in this case!)
  143. * **4 arguments**
  144. * If the first argument is ''!'', the result is the negation of the three-argument expression composed of the remaining arguments. Otherwise, the expression is parsed and evaluated according to precedence using the rules listed above
  145. * **5 or more arguments**
  146. * The expression is parsed and evaluated according to precedence using the rules listed above
  147.  
  148.  
  149. These rules may seem complex, but it's not so bad in practice. Knowing them might help you to explain some of the "unexplicable" behaviours you might encounter:
  150. <code>
  151. var=""
  152. if [ -n $var ]; then echo "var is not empty"; fi
  153. </code>
  154.  
  155. This code prints "var is not empty", even though ''-n something'' is supposed to be true if ''$var'' is not empty - **why?**
  156.  
  157. Here, as ''$var'' is **not quoted**, word splitting occurs and ''$var'' results in actually nothing (Bash removes it from the command's argument list!). So the test is in fact ''[ -n ]'' **and falls into the "one argument" rule**, the only argument is "-n" which is not null and so the test returns true. The solution, as usual, is to **quote the parameter expansion**: ''[ -n "$var" ]'' so that the test has always 2 arguments, even if the second one is the null string.
  158.  
  159. These rules also explain why, for instance, -a and -o can have several meanings.
  160.  
  161. ===== AND and OR =====
  162.  
  163.  
  164.  
  165.  
  166. ==== The Prefered Way ====
  167.  
  168. The way often recommended to logically connect several tests with AND and OR is to use **several single test commands** and to **combine** them with the shell ''&&'' and ''||'' **list control operators**.
  169.  
  170. See this:
  171. <code>
  172. if [ -n "$var"] && [ -e "$var"]; then
  173. echo "\$var is not null and a file named $var exists!"
  174. fi
  175. </code>
  176.  
  177. The return status of AND and OR lists is the exit status of the last command executed in the list
  178. * With ''command1 && command2'', ''command2'' is executed if, and only if, ''command1'' returns an exit status of zero (true)
  179. * With ''command1 ││ command2'', ''command2'' is executed if, and only if, ''command1'' returns a non-zero exit status (false)
  180.  
  181.  
  182.  
  183. ==== The other way: -a and -o ====
  184.  
  185. The logical operators AND and OR for the test-command itself are ''-a'' and ''-o'', thus:
  186. <code>
  187. if [ -n "$var" -a -e "$var" ] ; then
  188. echo "\$var is not null and a file named $var exists"
  189. fi
  190. </code>
  191.  
  192. They are **not** ''&&'' or ''||'':
  193. <code>
  194. $ if [ -n "/tmp" && -d "/tmp"]; then echo true; fi # DOES NOT WORK
  195. bash: [: missing `]'
  196. </code>
  197.  
  198. You might find the error message confusing, ''['' does not find the required final '']'', because as seen above ''&&'' is used to write a **list of commands**. The ''if'' statement actually **sees two commands**:
  199. * ''[ -n "/tmp"''
  200. * ''-d "/tmp" ]''
  201. ...which **must** fail.
  202.  
  203.  
  204.  
  205.  
  206. ==== Why you should avoid using -a and -o ====
  207.  
  208. === If portability is a concern ===
  209.  
  210. POSIX(r)/SUSv3 does **not** specify the behaviour of ''test'' in cases where there are more than 4 arguments. If you write a script that might not be executed by Bash, the behaviour might be different! ((<rant>Of course, one can wonder what is the use of including the parenthesis in the specification without defining the behaviour with more than 4 arguments or how usefull are the examples with 7 or 9 arguments attached to the specification.</rant>))
  211.  
  212. === If you want the cut behaviour ===
  213.  
  214. Let's say, we want to check the following two things (AND):
  215. - if a string is null (empty)
  216. - if a command produced an output
  217. Let's see:
  218. <code>
  219. if [ -z "false" -a -z "$(echo I am executed >&2)" ] ; then ...
  220. </code>
  221. => The arguments are all expanded **before** ''test'' runs, thus the echo-command **is executed**.
  222.  
  223. <code>
  224. if [ -z "false" ] && [ -z "$(echo I am not executed >&2)" ]; then...
  225. </code>
  226.  
  227. => Due to the nature of the ''&&'' list operator, the second test-command runs only if the first test-command returns true, our echo-command **is not executed**.
  228.  
  229. __**Note:**__ In my opinion, ''-a'' and ''-o'' are also less readable ''[pgas]''
  230.  
  231. ==== Precedence and Parenthesis ====
  232.  
  233. Take care if you convert your scripts from using ''-a'' and ''-o'' to use the list way (''&&'' and ''||''):
  234. * in the test-command rules, ''-a'' has **precedence over** ''-o''
  235. * in the shell grammar rules, ''&&'' and ''||'' have **equal precedence**
  236. That means, **you can get different results**, depending on the manner of use:
  237. <code>
  238. $ if [ "true" ] || [ -e /does/not/exist ] && [ -e /does/not/exist ]; then echo true; else echo false; fi
  239. false
  240.  
  241. $ if [ "true" -o -e /does/not/exist -a -e /does/not/exist ]; then echo true; else echo false;fi
  242. true
  243. </code>
  244. As a result you have to think about it a little or add precedence control (parenthesis).
  245.  
  246. For ''&&'' and ''||'' parenthesis means (shell-ly) grouping the commands, and since ''( ... )'' introduces a subshell we will use ''{ ... }'' instead:
  247. <code>
  248. $ if [ "true" ] || { [ -e /does/not/exist ] && [ -e /does/not/exist ] ;} ; then echo true; else echo false; fi
  249. true
  250. </code>
  251.  
  252. For the test command, the precedence parenthesis are, as well, ''( )'', but you need to escape or quote them, so that the shell doesn't try to interpret them:
  253. <code>
  254. $ if [ \( "true" -o -e /does/not/exist \) -a -e /does/not/exist ]; then echo true; else echo false; fi
  255. false
  256.  
  257. # equivalent, but less readable IMHO:
  258. $ if [ '(' "true" -o -e /does/not/exist ')' -a -e /does/not/exist ]; then echo true; else echo false; fi
  259. false
  260. </code>
  261.  
  262.  
  263.  
  264. ===== NOT =====
  265.  
  266. As for AND and OR, there are 2 ways to negate a test with the shell keyword ''!'' or passing ''!'' as an argument to ''test''.
  267.  
  268.  
  269. Here ''!'' negates the exit status of the command ''test'' which is 0 (true), and the else part is executed:
  270. <code>
  271. if ! [ -d '/tmp' ]; then echo "/tmp doesn't exists"; else echo "/tmp exists"; fi
  272. </code>
  273.  
  274. Here the ''test'' command itself exits with status 1 (false) and the else is also executed:
  275. <code>
  276. if [ ! -d '/tmp' ]; then echo "/tmp doesn't exists"; else echo "/tmp exists"; fi
  277. </code>
  278.  
  279. Unlike for AND and OR, both methods for NOT have an identical behaviour, at least for doing one single test.
  280.  
  281. ===== Pitfalls summarized =====
  282.  
  283. In this section you will get all the mentioned (and maybe more) possible pitfalls and problems in a summary.
  284.  
  285. ==== General ====
  286.  
  287. Here's the copy of a mail on bug-bash list. A user asking a question about using the test command in Bash, **he's talking about a problem, which you may have already had yourself**:
  288. <code>
  289. From: (PROTECTED)
  290. Subject: -d option not working. . .?
  291. Date: Tue, 11 Sep 2007 21:51:59 -0400
  292. To: bug-bash@gnu.org
  293.  
  294. Hi All,
  295.  
  296. I've got a script that I'm trying to set up, but it keeps telling me
  297. that "[-d command not found". Can someone please explain what is
  298. wrong with this?:
  299.  
  300.  
  301.  
  302.  
  303. #!/bin/sh
  304.  
  305. for i in $*
  306. do
  307. {
  308. if [-d $i]
  309. then
  310. echo "$i is a directory! Yay!"
  311. else
  312. echo "$i is not a directory!"
  313. fi
  314. }
  315. done
  316.  
  317.  
  318.  
  319. Regards
  320. </code>
  321.  
  322. See the problem regarding the used test-command (the other potential problems are not of interest here)?
  323. <code>
  324. [-d $i]
  325. </code>
  326. He simply didn't know that ''test'' or ''['' is a normal, simple command. Well, here's the answer he got. I quote it here, because it's a well written text that addresses most of the common issues with the "classic" test command:
  327.  
  328. <code>
  329. From: Bob Proulx (EMAIL PROTECTED)
  330. Subject: Re: -d option not working. . .?
  331. Date: Wed, 12 Sep 2007 10:32:35 -0600
  332. To: bug-bash@gnu.org
  333.  
  334. > (QUOTED TEXT WAS REMOVED)
  335.  
  336. The shell is first and foremost a way to launch other commands. The
  337. syntax is simply "if" followed by a command-list, (e.g. if /some/foo;
  338. or even if cmd1; cmd2; cmd3; then). Plus the '( ... )' syntax is
  339. already taken by the use of starting a subshell.
  340.  
  341. As I recall in the original shell language the file test operator was
  342. not built-in. It was provided by the standalone '/bin/test' command.
  343. The result was effectively this:
  344.  
  345. if /bin/test -d somedir
  346.  
  347. Although the full path /bin/test was never used. I showed it that way
  348. here for emphasis that following the 'if' statement is a command list.
  349. Normally it would simply have been:
  350.  
  351. if test -d somedir
  352.  
  353. Of course that is fine and for the best portability that style is
  354. still the recommended way today to use the test command. But many
  355. people find that it looks different from other programming languages.
  356. To make the test operator (note I mention the test operator and not
  357. the shell language, this is a localized change not affecting the
  358. language as a whole) look more like other programming languages the
  359. 'test' program was coded to ignore the last argument if it was a ']'.
  360. Then a copy of the test program could be used as the '[' program.
  361.  
  362. ...modify /bin/test to ignore ']' as last argument...
  363. cp /bin/test /bin/[
  364.  
  365. This allows:
  366.  
  367. if [ -d somedir ]
  368.  
  369. Doesn't that look more normal? People liked it and it caught on. It
  370. was so popular that both 'test' and '[' are now shell built-ins. They
  371. don't launch an external '/bin/test' program anymore. But they *used*
  372. to launch external programs. Therefore argument parsing is the same
  373. as if they still did launch an external program. This affects
  374. argument parsing.
  375.  
  376. it test -f *.txt
  377. test: too many arguments
  378.  
  379. Oops. I have twenty .txt files and so test got one -f followed by the
  380. first file followed by the remaining files. (e.g. test -f 1.txt 2.txt
  381. 3.txt 4.txt)
  382.  
  383. if test -d $file
  384. test: argument expected
  385.  
  386. Oops. I meant to set file.
  387.  
  388. file=/path/some/file
  389. if test -d $file
  390.  
  391. If variables such as that are not set then they wlll be expanded by
  392. the shell before passing them to the (possibly external) command and
  393. disappear entirely. This is why test arguments should always be quoted.
  394.  
  395. if test -d "$file"
  396. if [ -d "$file" ]
  397.  
  398. Actually today test is defined that if only one argument is given as
  399. in this case "test FOO" then then test returns true if the argument is
  400. non-zero in text length. Because "-d" is non-zero length "test -d" is
  401. true. The number of arguments affects how test parses the args. This
  402. avoids a case where depending upon the data may look like a test
  403. operator.
  404.  
  405. DATA="something"
  406. if test "$DATA" # true, $DATA is non-zero length
  407.  
  408. DATA=""
  409. if test "$DATA" # false, $DATA is zero length
  410.  
  411. But the problem case is how should test handle an argument that looks
  412. like an operator? This used to generate errors but now because it is
  413. only one argument is defined to be the same as test -n $DATA.
  414.  
  415. DATA="-d"
  416. if test "$DATA" # true, $DATA is non-zero length
  417. if test -d # true, same as previous case.
  418.  
  419. Because test and [ are possibly external commands all of the parts of
  420. them are chosen to avoid shell metacharacters. The Fortran operator
  421. naming was well known at the time (e.g. .gt., .eq., etc.) and was
  422. pressed into service for the shell test operator too. Comming from
  423. Fortran using -gt, -eq, etc. looked very normal.
  424.  
  425. Incorrect use generating unlikely to be intended results:
  426.  
  427. if test 5 > 2 # true, "5" is non-zero length, creates file named "2"
  428.  
  429. Intended use:
  430.  
  431. if test 5 -gt 2 # true (and no shell meta characters needing quoting)
  432.  
  433. Then much later, sometime in the mid 1980's, the Korn sh decided to
  434. improve upon this situation. A new test operator was introduced.
  435. This one was always a shell built-in and therefore could act upon the
  436. shell arguments directly. This is '[[' which is a shell keyword.
  437. (Keyword, metacharacters, builtins, all are different.) Because the
  438. shell processes [[ internally all arguments are known and do not need
  439. to be quoted.
  440.  
  441. if [[ -d $file ]] # okay
  442. if [[ 5 > 2 ]] # okay
  443.  
  444. I am sure that I am remembering a detail wrong but hopefully this is
  445. useful as a gentle introduction and interesting anyway.
  446.  
  447. Bob
  448. </code>
  449.  
  450. I hope this text protects you a bit from stepping from one pitfall into the next.
  451.  
  452. I find it very interesting and informative, that's why I quoted it here. Many thanks, Bob, also for the permission to copy the text here!
  453.  
  454. ===== Code examples =====
  455.  
  456. ==== Snipplets ====
  457.  
  458. Some code snipplets follow, different ways of shell reaction is used.
  459.  
  460. * **check if a variable is defined/non-NULL**
  461. * ''test "$MYVAR"''
  462. * ''[ "$MYVAR" ]''
  463. * **Note:** There are possibilities to make a difference if a variable is //undefined// or //NULL// - see [[syntax:pe#use_an_alternate_value|Parameter Expansion - Using an alternate value]]
  464. * **check if a directory exists, if not, create it**
  465. * ''test ! -d /home/user/foo && mkdir /home/user/foo''
  466. * ''[ ! -d /home/user/foo ] && mkdir /home/user/foo''
  467. * ''if [ ! -d /home/user/foo ]; then mkdir /home/user/foo; fi''
  468. * **check if minimum one parameter was given, and that one is "Hello"**
  469. * ''test $# -ge 1 -a "$1" = "Hello" || exit 1''
  470. * ''[ $# -ge 1 ] && [ "$1" = "Hello" ] || exit 1'' (see [[syntax:basicgrammar#lists | lists description]])
  471.  
  472.  
  473.  
  474. ==== Listing directories ====
  475.  
  476. Using a [[syntax:ccmd:classic_for | for-loop]] to iterate through all entries of a directory, if an entry is a directory (''[ -d "$fn" ]''), print its name:
  477.  
  478. <code>
  479. for fn in *; do
  480. [ -d "$fn" ] && echo "$fn"
  481. done
  482. </code>
  483.  
  484.  
  485. ===== See also =====
  486.  
  487. * Internal: [[syntax:ccmd:conditional_expression | conditional expression]] (aka "the new test command")
  488. * Internal: [[syntax:ccmd:if_clause | the if-clause]]
Advertisement
Add Comment
Please, Sign In to add comment
Advertisement